
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>LSTM_Base &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for LSTM_Base</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>
<span class="kn">import</span> <span class="nn">torch.nn</span> <span class="k">as</span> <span class="nn">nn</span>
<span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="kn">import</span> <span class="nn">pickle</span>

<div class="viewcode-block" id="LSTM_Base"><a class="viewcode-back" href="../sphinx/LSTM_Base.html#LSTM_Base.LSTM_Base">[docs]</a><span class="k">class</span> <span class="nc">LSTM_Base</span><span class="p">(</span><span class="n">nn</span><span class="o">.</span><span class="n">Module</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">model_name</span> <span class="o">=</span> <span class="s1">&#39;LSTM&#39;</span>                    <span class="c1"># The kind of model</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dataset_format</span> <span class="o">=</span> <span class="s1">&#39;You et al. [56]&#39;</span>     <span class="c1"># The dataset format</span>


<div class="viewcode-block" id="LSTM_Base.report"><a class="viewcode-back" href="../sphinx/LSTM_Base.html#LSTM_Base.LSTM_Base.report">[docs]</a>    <span class="k">def</span> <span class="nf">report</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Creates a little report with all of the information about the class.</span>

<span class="sd">                Returns</span>
<span class="sd">                -------</span>
<span class="sd">                str</span>
<span class="sd">                    A string with the report information.</span>
<span class="sd">                &quot;&quot;&quot;</span>

        <span class="n">string</span> <span class="o">=</span> \
            <span class="sa">f</span><span class="s2">&quot;  Model name: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">model_name</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Variant: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">variant</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Version: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">version</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Dataset Format: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset_format</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Delta: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">delta</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Hidden layer dimension: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">hidden_dim</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Pooling_layer: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">pooling_layer</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Dropout prob.: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dropout_value</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Number of linear layers: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">nb_layers</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>

        <span class="k">try</span><span class="p">:</span>
            <span class="n">string</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;  Dropout prob. (lin layers): </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">lin_dropout_fn</span><span class="o">.</span><span class="n">p</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>
        <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
            <span class="k">pass</span>

        <span class="k">return</span> <span class="n">string</span></div></div>

<div class="viewcode-block" id="Dataset_Base"><a class="viewcode-back" href="../sphinx/LSTM_Base.html#LSTM_Base.Dataset_Base">[docs]</a><span class="k">class</span> <span class="nc">Dataset_Base</span><span class="p">(</span><span class="n">Dataset</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">()</span>

<div class="viewcode-block" id="Dataset_Base.report"><a class="viewcode-back" href="../sphinx/LSTM_Base.html#LSTM_Base.Dataset_Base.report">[docs]</a>    <span class="k">def</span> <span class="nf">report</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Creates a little report with all of the information about the class.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        str</span>
<span class="sd">            A string with the report information.</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">string</span> <span class="o">=</span> \
            <span class="sa">f</span><span class="s2">&quot;  Dataset Name: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset_name</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Size of the training set: </span><span class="si">{</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Threshold (minimum capacity): </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">threshold</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Dimensionless variables: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">adimensionalize</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Minimum length: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">min_len</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Resampling time step: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">time_step</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Fixed Length: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">fixed_len</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Batteries used: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">batteries</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span> \
            <span class="sa">f</span><span class="s2">&quot;  Normalization information: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">norm</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>

        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle_lim</span> <span class="o">!=</span> <span class="mf">1e6</span><span class="p">:</span>
            <span class="n">string</span> <span class="o">+=</span> <span class="sa">f</span><span class="s2">&quot;  Maximum cycle number: </span><span class="si">{</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_lim</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>

        <span class="k">return</span> <span class="n">string</span></div>

<div class="viewcode-block" id="Dataset_Base.time_step_function"><a class="viewcode-back" href="../sphinx/LSTM_Base.html#LSTM_Base.Dataset_Base.time_step_function">[docs]</a>    <span class="k">def</span> <span class="nf">time_step_function</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Function for generating a time step when ``None`` is informed.</span>

<span class="sd">        This function makes some extremely arbitrary choices, but that are based</span>
<span class="sd">        on values of ``time_step`` that are known to work well with the</span>
<span class="sd">        available datasets.</span>

<span class="sd">        The function calculates the mean duration of the charge cycles in the</span>
<span class="sd">        given ``Battery_list``, and divides it by ``2*min_len`` to get the</span>
<span class="sd">        time_step. The factor 2 is there to ensure that most of the cycles will</span>
<span class="sd">        have more than ``fixed_len`` points after resampling. It could be lower</span>
<span class="sd">        or higher, but the results currently obtained for the available datasets</span>
<span class="sd">        match well the manually tested ones.</span>

<span class="sd">        Returns</span>
<span class="sd">        -------</span>
<span class="sd">        time_step : float</span>
<span class="sd">            The time step [s].</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="n">time_tensor</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">]])</span>  <span class="c1"># empty tensor</span>
        <span class="k">for</span> <span class="n">Battery</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">Battery_list</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">cycle_couple</span> <span class="ow">in</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">:</span>
                <span class="n">chr_cycle</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">dt</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">Tensor</span><span class="p">([[</span><span class="n">chr_cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">time</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">item</span><span class="p">(),</span>
                                 <span class="n">chr_cycle</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">time</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">item</span><span class="p">()]])</span>

                <span class="n">time_tensor</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">cat</span><span class="p">([</span><span class="n">time_tensor</span><span class="p">,</span>
                                      <span class="n">dt</span><span class="p">],</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

        <span class="n">time_tensor</span> <span class="o">=</span> <span class="n">time_tensor</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:]</span>
        <span class="n">mean_times</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">time_tensor</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">time_step</span> <span class="o">=</span> <span class="p">(</span><span class="n">mean_times</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">mean_times</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span> <span class="o">/</span> <span class="p">(</span><span class="mi">2</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">min_len</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Time step: (in seconds)&quot;</span><span class="p">,</span> <span class="n">time_step</span><span class="o">.</span><span class="n">item</span><span class="p">())</span>
        <span class="k">return</span> <span class="n">time_step</span><span class="o">.</span><span class="n">item</span><span class="p">()</span></div>


<div class="viewcode-block" id="Dataset_Base.dataset_info"><a class="viewcode-back" href="../sphinx/LSTM_Base.html#LSTM_Base.Dataset_Base.dataset_info">[docs]</a>    <span class="k">def</span> <span class="nf">dataset_info</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Method for creating and information tuple that can be loaded for</span>
<span class="sd">        creating a similar dataset in the future.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        name : str</span>
<span class="sd">            The name of the file where the tuple will be dumped.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">info_tuple</span> <span class="o">=</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">batteries</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">time_step</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">fixed_len</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span>

        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">name</span><span class="o">+</span><span class="s1">&#39;_info_tuple_.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">pickle</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">info_tuple</span><span class="p">,</span> <span class="n">f</span><span class="p">)</span></div></div>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>